/* Copyright (C) 1999 PLUS Group - University of Maryland
 *	
 * This software is provided under the terms of the GNU General Public
 * License Version 2, June 1991. See the header in SS_Frame.java
 * and the file License.html for details.
 */

package ShoeSearch;

import java.awt.*;
import java.applet.*;
import java.util.*;
import UserInt.ApplType;
import HTML.AltProxyUrl;

public class SS_Button extends Applet
{
  protected final static int WIN_WIDTH = 750;
  protected final static int WIN_HEIGHT = 500;

  protected String kbHost = null;
  protected int kbPort = 0;
  protected String kbName = null;

  protected Label status;
  protected Button bStart;

  protected String buttonLabel = "SHOE Search";
  protected String initMsg = "Press the button to begin your search.";
  protected String waitMsg = "Initializing. Please wait...";
  protected String doneMsg = "Search window opened.";

  protected String webProxyHost = null;
  protected int    webProxyPort = 8080;
 
  public void init()
  { 
      super.init();

      // get the background color parameter, and if specified set it
      String colorString;
      int    colorInt;
      
      colorString = getParameter("BGCOLOR");
      if (colorString != null) {
	try {
	  colorInt = (Integer.decode(colorString)).intValue();
	  setBackground(new Color(colorInt));
	  bStart.setBackground(Color.lightGray);  // keep button gray
	} catch (NumberFormatException ex) {
	  System.err.println("Invalid BGCOLOR parameter, using default");
	}
      }

      status = new Label(initMsg);
      bStart = new Button(buttonLabel);
      add (status, Label.LEFT);
      add (bStart);
      ApplType.setApplet();

      kbHost = getParameter("Host");
      try {
	kbPort = Integer.parseInt(getParameter("Port"));
      } catch (NumberFormatException ex) {
	kbPort = 0;
      }
      kbName = getParameter("KB");

      // prepare code for use with a proxy web server on applet's host
      webProxyHost = getCodeBase().getHost();
      AltProxyUrl.setWebProxy(webProxyHost, webProxyPort);
  }

  public boolean action(Event evt, Object arg)
  {
      if (evt.target instanceof Button)
      {
	  if ((evt.target == bStart) && (evt.id == Event.ACTION_EVENT))
  	  {
	      AppletContext context = getAppletContext();
	      context.showStatus(waitMsg);
	      status.setText(waitMsg);
/* TEST
	      System.out.println ("applet context:  " + context.toString());
*/
	      displayFrame();
	      context.showStatus(doneMsg);
	      status.setText(doneMsg);
	  }
	  return true;
      }
      //return  super.action(evt, arg);
      return false;
  }

  public void displayFrame() {

    SS_Frame win = new SS_Frame(kbHost, kbPort, kbName, this);
    win.resize(WIN_WIDTH, WIN_HEIGHT);
    win.show();
  }

}
