/* Copyright (C) 1999 PLUS Group - University of Maryland
 *	
 * This software is provided under the terms of the GNU General Public
 * License Version 2, June 1991. See the header in SS_Frame.java
 * and the file License.html for details.
 */

package ShoeSearch;

import  java.io.*;

public class  ThesCommand extends java.lang.Object
{
    // PARKA command list:
    //
    static final String  EXPAND        = "20000";
    static final String  GETRESULTS    = "20001";

    static final String  DISCONNECT    = "close";
    //close socket connection from client
    //Response class not used after this one (no response is there).

    int     sizeOfCmd;
    String  sizeOfCmdStr;
    String  cmdStr;
    OutputStream   outstream;

    ThesCommand (OutputStream out, String cmd, String arglist)
    {
        if (arglist.length() > 0)
           cmdStr = cmd + " " + arglist;
        else
           cmdStr = cmd;
        sizeOfCmd = cmdStr.length();
        sizeOfCmdStr = String.valueOf(sizeOfCmd) + " ";
        outstream = out;
    }

    // Send command to Thesaurus Server.
    // It is the user's responsibility to have already set up the
    // communication channels before calling this routine.
    //
    void sendCommand()
    {
        // convert to byte array
        String tmpstr = sizeOfCmdStr + cmdStr;
        byte cmd[]    = new byte[tmpstr.length()];
        tmpstr.getBytes(0, tmpstr.length(), cmd, 0);

        try
        {
/* TEST
            System.out.print("Print thesaurus command: ");
            System.out.println(tmpstr);
*/
            // Write to output stream
            outstream.write (cmd, 0, tmpstr.length());
	         //args: byte array to write from; offset; length.
            outstream.flush();
        }
        catch (IOException e1)
        {
            System.out.println("IO Error in sendCommand");
            System.out.println("   Command is " + cmdStr);
        }
    }
}
